
function bootset_splitarg(arg)
{
	o = {
		'arg': arg,
		'opt': ''
	};
	i = arg.indexOf(' ');
	if (i > -1)
	{
		o.arg = arg.substring(0, i);
		o.opt = arg.substring(i + 1);
	}
	return o;
}

var bootset_schema;
var bootset_done = 0;

$.getJSON('/plugin/boot-settings/jsonschema.jim', function(data) {
	// Populate the add parameter select box
	$('#bootset_add').empty();
	$.each(data, function(k, v) {
		$('#bootset_add').append(
		    $('<option></option>').attr('value', k).html(k)
		);

	});
	bootset_schema = data;
	bootset_done++;
});

$.getJSON('/cgi-bin/chanlist.jim', function(data) {
	$('#bootset_chlist').empty();
	$.each(data, function(k, v) {
		$('#bootset_chlist').append(
		    $('<option></option>').attr('value', k).html(k + ' - ' + v)
		);
	});
	bootset_done++;
});

$.getJSON('/cgi-bin/favlist.jim', function(data) {
	$('#bootset_favlist').empty();
	$.each(data, function(k, v) {
		$('#bootset_favlist').append(
		    $('<option></option>').attr('value', k).html(k + ' - ' + v)
		);
	});
	bootset_done++;
});

function bootset_add(param, val)
{
	var o = bootset_schema[param];
	var gui = bootset_splitarg(o.gui);

	//console.dir(o);
	//console.log('Adding: ' + gui.arg);
	//console.dir(gui);

	$row = $('#bootset_template_' + gui.arg)
	    .clone()
	    .removeAttr('id')
	    .addClass(gui.arg + ' ' + o.field)
	    .attr('bstype', gui.arg)
	    .removeClass('hidden');

	$row.find('th.param').html(param);
	if (o.unit !== undefined)
		$row.find('.unit').html(o.unit);

	$row.append(
	    $('<td><a class=bsdel href=#>' +
	      '<img class=bsdel src=/img/close.png height=24>' +
	      '</a></td>'));

	// Make row visible now so that the iphone checkbox renders at correct
	// width.
	$('#bootset_tab > tbody').append($row);

	$i = $row.find('input.val,select.val');
	opts = gui.opt.split(" ");
	switch (gui.arg)
	{
	    case "chlist":
	    case "favlist":
		if (val !== undefined)
			$i.val(val);
		break;
		
	    case "boolean":
		$i.attr('type', 'checkbox');
		if (val !== undefined && val > 0)
			$i.prop('checked', true);
		$i.iphoneStyle({
			checkedLabel: 'ON',
			uncheckedLabel: 'OFF'
		});
		break;

	    case 'select':
		var arr = [];

		while (opts.length)
			arr.push(opts.splice(0, 2));
		$.each(arr, function(k, v) {
			$i.append(
			    $('<option></option>').attr('value', v[0])
			    .html(v[1])
			);
		});
		if (val !== undefined)
			$i.val(val);
		break;

	    case "slider":
		$slider = $row.find('.bootset_slider');
		if (val !== undefined)
			$i.val(val);
		else if (opts[2] !== undefined)
			$i.val(opts[2]);
		if (opts[0] !== undefined)
			$i.attr('min', opts[0]);
		if (opts[1] !== undefined)
			$i.attr('max', opts[1]);

		so = {
			range: "min",
			min: ~~$i.attr('min'),
			max: ~~$i.attr('max'),
			value: $i.val(),
			slide: function(e, ui) {
				$(this).siblings('input').val(ui.value);
			}
		};
		//console.dir(so);
		$slider.slider(so);
		break;

	    case "int":
		if (val !== undefined)
			$i.val(val);
		else if (opts[2] !== undefined)
			$i.val(opts[2]);
		if (opts[0] !== undefined)
			$i.attr('min', opts[0]);
		if (opts[1] !== undefined)
			$i.attr('max', opts[1]);
		break;
	}

	return $row;
}

$('#bootset_add_button').button({icons: {primary: "ui-icon-plus"}})
    .on('click', function() {
	var param = $('#bootset_add').val();
	bootset_add(param);
});

$('#bootset_save').button({icons: {primary: "ui-icon-disk"}})
    .on('click', function() {
	data = {};
	$('#bootset_save').disable();
	$('#bootset_saving').empty().html('<img src=/img/spin.gif> ' +
	    'Saving...').show('fast');
	index = 0;
	$('#bootset_tab tbody tr').each(function() {
		var param = $(this).find('th.param').text();
		var o = bootset_schema[param];
		var $i = $(this).find('input.val,select.val')
		switch ($(this).attr('bstype'))
		{
		    case 'boolean':
			val = $i.prop('checked') ? 1 : 0;
			break;
		    default:
			val = $i.val();
		}
		if (!val) val = 0;
		index++;
		data[index + ':' + param] = val;
	});
	//console.log('save');
	//console.dir(data);
	$.post('/plugin/boot-settings/save.jim', data, function() {
		$('#bootset_saving').delay(2000).empty().html('Saved')
		    .delay(4000).fadeOut('slow');
		$('#bootset_save').enable();
	});
});

$('#bootset_tab').on('click', 'a.bsdel', function(e) {
	e.preventDefault();
	$(this).closest('tr').addClass('strike').delay(500)
	    .slideUp('slow', function() {
		$(this).remove();
	});
});

//function bootset_testdata()
//{
//	bootset_add('PIN', 1234);
//	bootset_add('Volume');
//	bootset_add('Channel', 200);
//	bootset_add('Content Sharing', 1);
//	bootset_add('FTP Server', 0);
//	bootset_add('OSD Timeout', 7);
//}

function bootset_load()
{
	if (bootset_done < 3)
	{
		setTimeout(bootset_load, 100);
		return;
	}
	$.getJSON('/plugin/boot-settings/load.jim', function(data) {
		$.each(data, function(k, v) {
			bootset_add(k, v);
		});
	});
}

$(function() {
	setTimeout(bootset_load, 100);
	//setTimeout(bootset_testdata, 2000);
});

